;                        ---=====* FLGFACE.lsp *=====---
;
;                        Programed By: Dennis M. Sauro
;                             Date Created: 09-15-89
;                            Last Modified: 2-19-91
;
;**********************************************************************
(defun DTR (ANG)
   (* pi (/ ANG 180.0))
)
;**********************************************************************
(defun RTD (RAD)
   (/ (* RAD 180.0) pi)
)
;**********************************************************************
(defun C:FLGFACE ( / ORIG PS REC PO DBASE O F BD BC NB PI
DIR RAD BA BR HC P1 AB AD AU AP LU LP BP CM HL REPEAT ASK)

(princ "\n                                       FlgFACE    v1.2  Evaluation Copy ")
(princ "\n                                      By -*CADsultants*- CopyRight 1990 ")
(princ)

(setq DIR (getenv "flg-pak"))
(setq clay (getvar "clayer")
      bp (getvar "blipmode")
      cm (getvar "cmdecho")
      hl (getvar "highlight"))
(setvar "blipmode" 0)
(setvar "Cmdecho" 0)
(setvar "highlight" 0)
(setq CHK (getvar "useri1"))
(if (= CHK nil)(setvar "useri1" 1))
(setq lu (getvar "lunits")
      lp (getvar "luprec")
      au (getvar "aunits")
      ap (getvar "auprec")
      ad (getvar "angdir")
      ab (getvar "angbase")
      sa (getvar "snapang"))
(command "setvar" "aunits" "0")
(command "setvar" "angdir" "1")
(command "setvar" "angbase" "270")
(command "setvar" "snapang" "90")
(command "setvar" "auprec" "4")
(command "setvar" "lunits" "2")
(command "setvar" "luprec" "4")

(setq repeat 1)
(while repeat 1

 (if (/= RT nil)(progn
 (setq temp RT)
 (setq RT (getreal (strcat "\nFlange Rating=150/300/400/600/900/1500/2500: <"
 (rtos RT 2 0) "> ")))
 (if (= RT nil)(setq RT temp))
   (if (/= RT 150) (progn
   (setq RT 150)
   (princ "\nRegister Today and get the Complete Package")
   (getstring "\nYou can ONLY Create a 150# Ratings.... Sorry ")(princ)
   ))
 ))

 (if (= RT nil)(progn
 (setq RT (getreal "\nFlange Rating=150/300/400/600/900/1500/2500: <150> "))
 (if (= RT nil)(setq RT 150))
   (if (/= RT 150) (progn
   (setq RT 150)
   (princ "\nRegister Today and get the Complete Package")
   (getstring "\nYou can ONLY Create a 150# Ratings.... Sorry ")(princ)
   ))
 ))

 (if (/= NO nil)(progn
 (setq temp NO)
 (setq NO (getreal (strcat "\nNominal Size of Pipe [Inches]: <"
 (rtos NO 2 2) "> ")))
 (if (= NO nil)(setq NO temp))
 ))


 (if (= NO nil)(progn
 (setq NO (getreal "\nNominal Size of Pipe [Inches]: "))
 ))

 (if (/= WA nil)(progn
 (setq temp WA)
 (setq WA (strcase
 (getstring (strcat "\nWall Thk'ness=STD/40/XHVY/80/160/XXHVY/SPecify: <"
 WA "> "))))
 (if (= WA "")(setq WA temp))

  (if (/= WT nil)(progn
  (setq temp WT)
  (if (= WA "SP")(setq WT (getreal
  (strcat "\nWall Thk'ness [Decimal of Inch]: <" (rtos WT) "> "))))
  (if (= WT nil)(setq WT temp))
  ))

  (if (= WT nil)(progn
  (if (= WA "SP")(setq WT (getreal "\nWall Thk'ness [Decimal of Inch]: ")))
  ))

 ))

 (if (= WA nil)(progn
 (setq WA (strcase
 (getstring "\nWall Thk'ness=STD/40/XHVY/80/160/XXHVY/SPecify: <STD> ")))
 (if (= WA "SP")(setq WT (getreal "\nWall Thk'ness [Decimal of Inch]:  ")))
 (if (= WA "")(setq WA "STD"))
 ))

 (setq ORIG (getpoint "\nFlange Center Point: "))

;End of GETORI

(command "layer" "t" "main,center,hidden" "")
(princ "\nPlease Wait Reading-in FLANGE Information....")

;*********** READ Nozzle DataBase and look for Nominal Pipe Size ************
   (if (= RT 150) (setq DBASE (OPEN (strcat DIR "\\150.DAT") "r")))

       (setq PS 0)
          (setq REC (READ-LINE DBASE))
             (while (and (/= NO PS) (/= (substr REC 1 1) nil))
               (setq REC (READ-LINE DBASE))
               (setq PS (atof(substr REC 1 5)))
             ) ;End of Loop
        (close DBASE)
;End to Nozzle DBASE READ

       (setq PS 0)
          (setq PBASE (OPEN (strcat DIR "\\PIPE.DAT") "r"))
            (setq PIPE (READ-LINE PBASE))
             (while (and (/= NO PS) (/= (substr PIPE 1 1) nil))
               (setq PIPE (READ-LINE PBASE))
               (setq PS (atof(substr PIPE 1 5)))
             ) ;End of Loop
        (close PBASE)

;End to Nozzle PBASE READ
           (setq PO (atof(substr PIPE 7 6)))
             (if (= WA "STD")(setq WT (atof(substr PIPE 14 5))))
               (if (= WA "40")(setq WT (atof(substr PIPE 20 5))))
                 (if (= WA "XHVY")(setq WT (atof(substr PIPE 26 5))))
                   (if (= WA "80")(setq WT (atof(substr PIPE 32 5))))
                    (if (= WA "160")(setq WT (atof(substr PIPE 38 5))))
                     (if (= WA "XXHVY")(setq WT (atof(substr PIPE 44 5))))


(setq O (atof(substr REC 7 6)))
           (setq F (atof(substr REC 21 7))
                BD (atof(substr REC 64 5))
                BC (atof(substr REC 70 6))
                NB (atoi(substr REC 77 2)))
           (if (= TYP "SW") (setq SB (atof(substr REC 99 5))))
           (setq PI (- PO (* WT 2))
                 BA (/ (/ 360 NB) 2)
                 BR (/ BC 2)
                 HC (strcat "@" (rtos BR) "<" (rtos BA)))
(Command "layer" "s" "main" "")

;********************* Flg Construction **********************

  (setq RAD (/ O 2))
  (command "layer" "s" "main" "")
  (command "circle" ORIG "d" O)
  (command "layer" "s" "center" "")
  (setq P1 (strcat "@" (rtos RAD) "<25"))
  (command "ID" ORIG)
  (command "dim1")
  (command "cen" P1)
  (command "layer" "s" "main" "")
  (command "circle" ORIG "d" F)
  (if (/= TYP "SW")(progn
  (command "circle" ORIG "d" PI)
  ))
  (if (= TYP "SW")(progn
  (command "circle" ORIG "d" SB)
  ))
  (command "layer" "s" "hidden" "")
  (command "circle" ORIG "d" PO)
  (command "layer" "s" "main" "")
     (command "ID" ORIG)
  (command "circle" HC "d" BD)
  (command "array" "l" "" "p" ORIG NB "" "")
 (command "layer" "s" "main" "")
 (command"layer" "s" clay "")
 (setvar "angbase" ab)
 (setvar "angdir" ad)
 (setvar "aunits" au)
 (setvar "auprec" ap)
 (setvar "lunits" lu)
 (setvar "luprec" lp)
 (setvar "snapang" sa)
 (setvar "blipmode" bp)
 (setvar "Cmdecho" cm)
 (setvar "highlight" hl)
(princ "   ")(princ)
(princ (strcat "\n  " (rtos NO 2 2) "\042 "
(rtos RT 2 0) "# Flange Plan View Completed          FlgFACE   (C)1990\n"))
(setq ASK (strcase
(getstring "\nGenerate Another Flange Face <N>: ")))
  (if (= ASK "")(setq ASK "N"))
    (if (/= ASK "Y") (setq REPEAT nil))
); End of While Loop
(princ)
); End of Program